/*
 * BIOS interrupt 17h handler
 */

#include <stdlib.h>

#include "miscemu.h"
#include "wine/hardware.h"
#include "wine/debug.h"
#include "msdos.h"
#include "winnt.h"

WINE_DEFAULT_DEBUG_CHANNEL(int);

/**********************************************************************
 *          DOSVM_Int17Handler
 *
 * Handler for int 17h (printer - output character).
 */
void WINAPI DOSVM_Int17Handler( CONTEXT86 *context )
{
    switch( AH_reg(context) )
    {
	case 0x01:		/* PRINTER - INITIALIZE */
	    FIXME("Initialize Printer - Not Supported\n");
	    AH_reg(context) = 0; /* time out */
            break;
	case 0x02:		/* PRINTER - GET STATUS */
	    FIXME("Get Printer Status - Not Supported\n");
            break;
	default:
	    AH_reg(context) = 0; /* time out */
	    INT_BARF( context, 0x17 );
    }
}
